Get Even More Visitors To Your Blog, Upgrade To A Business Listing >>

Install Nagios on Ubuntu 18.04 Server

In this post we will Install Nagios on Ubuntu 18.04.  Nagios is a solid network monitoring tool that has a bit of a learning curve.

We are going to install Nagios Core 4.4.2 which is the latest open source version of Nagios as of this writing.

We will start off with a fresh install of Ubuntu Server 18.04 and perform all the updates.   Next we will reboot.

sudo apt update && apt upgrade -y

Next, do a reboot in case we got a new kernel.

reboot

We are now ready to install Nagios.

Installing Nagios Server

First lets download Nagios

wget https://assets.nagios.com/downloads/nagioscore/releases/nagios-4.4.2.tar.gz

We also need to download Nagios plugins.

wget https://nagios-plugins.org/download/nagios-plugins-2.2.1.tar.gz

Next we need to untar both tarballs.

tar -xzvf nagios-4.4.2.tar.gz
tar -xzvf nagios-plugins-2.2.1.tar.gz

We are going to install Nagios Core from source which means are going to have to build it.

But first we need to install some dependencies.

sudo apt-get install wget build-essential apache2 php php-gd libgd-dev unzip sendmail

Create Nagios User

We are going to create a nagios user and a user group called nagcmd.

We will then add the nagios user to the nagcmd user group.

finally we will add both the nagios user and the nagcmd user group to the www-data group.

Run the following commands:

useradd nagios
groupadd nagcmd
usermod -aG nagcmd nagios
usermod -aG nagios,nagcmd www-data

Building Nagios

Now it is time to build Nagios from source.

Change to the nagios-4.4.2 directory.

cd nagios-4.4.2/

Next run the configuration script.

./configure --with-command-group=nagcmd --with-mail=/usr/bin/sendmail --with-httpd-conf=/etc/apache2/

This tells the nagios build scripts to set the command group to the nagcmd user group, send emails using sendmail, and tells it where to put our web site configuration.

Now lets compile everything.  Run the following commands.

make all

Now we need to use make to install everything.

make install
make install-init
make install-config
make install-commandmode
make install-webconf

Awesome we now have Nagios Core installed.  But we have no configuration at this point.

Configuring Nagios Core

The tarball we downloaded earlier comes with some sample configuration files.

Let’s copy those over.

cp -R contrib/eventhandlers/ /usr/local/nagios/libexec/
chown -R nagios:nagios /usr/local/nagios/libexec/eventhandlers

Now lets verify that our config is good to go.

/usr/local/nagios/bin/nagios -v /usr/local/nagios/etc/nagios.cfg

You should see something like this:

Nagios Core 4.4.2
Copyright (c) 2009-present Nagios Core Development Team and Community Contributors
Copyright (c) 1999-2009 Ethan Galstad
Last Modified: 2018-08-16
License: GPL

Website: https://www.nagios.org
Reading configuration data...
   Read main config file okay...
   Read object config files okay...

Running pre-flight check on configuration data...

Checking objects...
  Checked 8 services.
  Checked 1 hosts.
  Checked 1 host groups.
  Checked 0 service groups.
  Checked 1 contacts.
  Checked 1 contact groups.
  Checked 24 commands.
  Checked 5 time periods.
  Checked 0 host escalations.
  Checked 0 service escalations.
Checking for circular paths...
  Checked 1 hosts
  Checked 0 service dependencies
  Checked 0 host dependencies
  Checked 5 timeperiods
Checking global event handlers...
Checking obsessive compulsive processor commands...
Checking misc settings...

Total Warnings: 0
Total Errors:   0

Things look okay - No serious problems were detected during the pre-flight check

Everything looks good.

So now we can enable our nagios site.  Run the following commands:

cp /etc/apache2/nagios.conf /etc/apache2/sites-available/nagios.conf
a2ensite nagios
a2enmod rewrite cgi

Restart Apache to enable the rewrite module and our new site.

systemctl restart apache2

Now let’s configure SystemD.

Edit a new file /etc/init.d/nagios and add the following contents:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          skeleton
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Example initscript
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

# Author: Foo Bar 
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Nagios"
NAME=nagios
DAEMON=/usr/local/nagios/bin/$NAME
DAEMON_ARGS="-d /usr/local/nagios/etc/nagios.cfg"
PIDFILE=/usr/local/nagios/var/$NAME.lock
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
  # Return
  #   0 if daemon has been started
  #   1 if daemon was already running
  #   2 if daemon could not be started
  start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
    || return 1
  start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
    $DAEMON_ARGS \
    || return 2
  # Add code here, if necessary, that waits for the process to be ready
  # to handle requests from services started subsequently which depend
  # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
  # Return
  #   0 if daemon has been stopped
  #   1 if daemon was already stopped
  #   2 if daemon could not be stopped
  #   other if a failure occurred
  start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
  RETVAL="$?"
  [ "$RETVAL" = 2 ] && return 2
  # Wait for children to finish too if this is a daemon that forks
  # and if the daemon is only ever run from this initscript.
  # If the above conditions are not satisfied then add some other code
  # that waits for the process to drop all resources that could be
  # needed by services started subsequently.  A last resort is to
  # sleep for some time.
  start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
  [ "$?" = 2 ] && return 2
  # Many daemons don't delete their pidfiles when they exit.
  rm -f $PIDFILE
  return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
  #
  # If the daemon can reload its configuration without
  # restarting (for example, when it is sent a SIGHUP),
  # then implement that here.
  #
  start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
  return 0
}

case "$1" in
  start)
  [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
  do_start
  case "$?" in
    0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
    2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  esac
  ;;
  stop)
  [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
  do_stop
  case "$?" in
    0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
    2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  esac
  ;;
  status)
  status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
  ;;
  #reload|force-reload)
  #
  # If do_reload() is not implemented then leave this commented out
  # and leave 'force-reload' as an alias for 'restart'.
  #
  #log_daemon_msg "Reloading $DESC" "$NAME"
  #do_reload
  #log_end_msg $?
  #;;
  restart|force-reload)
  #
  # If the "reload" option is implemented then remove the
  # 'force-reload' alias
  #
  log_daemon_msg "Restarting $DESC" "$NAME"
  do_stop
  case "$?" in
    0|1)
    do_start
    case "$?" in
      0) log_end_msg 0 ;;
      1) log_end_msg 1 ;; # Old process is still running
      *) log_end_msg 1 ;; # Failed to start
    esac
    ;;
    *)
    # Failed to stop
    log_end_msg 1
    ;;
  esac
  ;;
  *)
  #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
  echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
  exit 3
  ;;
esac

:

Save the file and restart everything.

systemctl restart apache2
systemctl start nagios
systemctl enable nagios

Create an Admin user for the web interface.

We need to create an administrator user for when we access the Nagios web interface.

Run the following command to create a nagiosadmin account.

htpasswd -c /usr/local/nagios/etc/htpasswd.users nagiosadmin

Enter the password you want to use.

Now we need to build and install the Nagios Plugins that we downloaded earlier.

Install Nagios Plugins

First we need to change to the plugins directory we created.

cd ../nagios-plugins-2.2.1/

Run the configuration script.

./configure --with-nagios-user=nagios --with-nagios-group=nagios

Build and install the plugins.

make
make install

We now have everything installed and we can view our Nagios web application.

Browse to the following URL.

http://{your_server}/nagios

You will see the Nagios web interface.

Conclusion

In this post, we installed Nagios Core and some sample plugins.  In a later post, I will walk you through how to configure a Nagios agent so that we can monitor everything.

I hope you have enjoyed this post.

If you did then please share it and comment below.

Click here if you would like to see other great Ubuntu articles from AdminTome Blog.

The post Install Nagios on Ubuntu 18.04 Server appeared first on AdminTome Blog.



This post first appeared on AdminTome, please read the originial post: here

Share the post

Install Nagios on Ubuntu 18.04 Server

×

Subscribe to Admintome

Get updates delivered right to your inbox!

Thank you for your subscription

×